Main Page Class Hierarchy Alphabetical List Compound List File List Compound Members File Members Related Pages

# ACE_Message_Queue_Ex Class Template Reference

A threaded message queueing facility, modeled after the queueing facilities in System V STREAMs. More...

`#include <Message_Queue_T.h>`

Collaboration diagram for ACE_Message_Queue_Ex:

[legend]
List of all members.

## Public Types
enum | { DEFUALT_PRIORITY = 0 }
## Public Methods
| ACE_Message_Queue_Ex (size_t high_water_mark = ACE_Message_Queue_Base::DEFAULT_HWM, size_t low_water_mark = ACE_Message_Queue_Base::DEFAULT_LWM, ACE_Notification_Strategy * = 0)
virtual int | open (size_t hwm = ACE_Message_Queue_Base::DEFAULT_HWM, size_t lwm = ACE_Message_Queue_Base::DEFAULT_LWM, ACE_Notification_Strategy * = 0)
virtual int | close (void)
| Close down the message queue and release all resources.
virtual | ~ACE_Message_Queue_Ex (void)
| Close down the message queue and release all resources.
virtual int | peek_dequeue_head (ACE_MESSAGE_TYPE *&first_item, ACE_Time_Value *timeout = 0)
virtual int | enqueue_prio (ACE_MESSAGE_TYPE *new_item, ACE_Time_Value *timeout = 0)
virtual int | enqueue (ACE_MESSAGE_TYPE *new_item, ACE_Time_Value *timeout = 0)
virtual int | enqueue_tail (ACE_MESSAGE_TYPE *new_item, ACE_Time_Value *timeout = 0)
virtual int | enqueue_head (ACE_MESSAGE_TYPE *new_item, ACE_Time_Value *timeout = 0)
virtual int | dequeue (ACE_MESSAGE_TYPE *&first_item, ACE_Time_Value *timeout = 0)
| This method is an alias for the following <dequeue_head> method.
virtual int | dequeue_head (ACE_MESSAGE_TYPE *&first_item, ACE_Time_Value *timeout = 0)
virtual int | is_full (void)
| True if queue is full, else false.
virtual int | is_empty (void)
| True if queue is empty, else false.
virtual size_t | message_bytes (void)
virtual size_t | message_length (void)
virtual size_t | message_count (void)
virtual void | message_bytes (size_t new_size)
virtual void | message_length (size_t new_length)
virtual size_t | high_water_mark (void)
virtual void | high_water_mark (size_t hwm)
virtual size_t | low_water_mark (void)
virtual void | low_water_mark (size_t lwm)
virtual int | deactivate (void)
virtual int | activate (void)
virtual int | deactivated (void)
| Returns true if <deactivated_> is enabled.
virtual int | notify (void)
virtual ACE_Notification_Strategy* | notification_strategy (void)
| Get/set the notification strategy for the <Message_Queue>.
virtual void | notification_strategy (ACE_Notification_Strategy *s)
virtual ACE_SYNCH_MUTEX_T& | lock (void)
| Returns a reference to the lock used by the .
virtual void | dump (void) const
| Dump the state of an object.
## Public Attributes
| ACE_ALLOC_HOOK_DECLARE
| Declare the dynamic allocation hooks.
## Private Attributes
ACE_Message_Queue<ACE_SYNCH_USE> | queue_
| Implement this via an .

## Detailed Description

### template<class ACE_MESSAGE_TYPE, ACE_SYNCH_DECL> template class ACE_Message_Queue_Ex

A threaded message queueing facility, modeled after the queueing facilities in System V STREAMs.

An is a strongly-typed version of the . If is then all operations are thread-safe. Otherwise, if it's then there's no locking overhead.

## Member Enumeration Documentation

template<classACE_MESSAGE_TYPE, ACE_SYNCH_DECL>
anonymous enum

  | Enumeration values:
  DEFUALT_PRIORITY |

## Constructor & Destructor Documentation

template<classACE_MESSAGE_TYPE, ACE_SYNCH_DECL>
ACE_Message_Queue_Ex<ACE_MESSAGE_TYPE, >::ACE_Message_Queue_Ex<ACE_MESSAGE_TYPE, > ( | size_t high_water_mark = ACE_Message_Queue_Base::DEFAULT_HWM,
| size_t low_water_mark = ACE_Message_Queue_Base::DEFAULT_LWM,
| ACE_Notification_Strategy * ns = 0 )

| Initialize an . The <high_water_mark> determines how many bytes can be stored in a queue before it's considered "full." Supplier threads must block until the queue is no longer full. The <low_water_mark> determines how many bytes must be in the queue before supplier threads are allowed to enqueue additional s. By default, the <high_water_mark> equals the <low_water_mark>, which means that suppliers will be able to enqueue new messages as soon as a consumer removes any message from the queue. Making the <low_water_mark> smaller than the <high_water_mark> forces consumers to drain more messages from the queue before suppliers can enqueue new messages, which can minimize the "silly window syndrome."

template<classACE_MESSAGE_TYPE, ACE_SYNCH_DECL>
ACE_Message_Queue_Ex<ACE_MESSAGE_TYPE, >::~ACE_Message_Queue_Ex<ACE_MESSAGE_TYPE, > ( | void )`[virtual]`

| Close down the message queue and release all resources.

## Member Function Documentation

template<classACE_MESSAGE_TYPE, ACE_SYNCH_DECL>
ACE_INLINE int ACE_Message_Queue_Ex< ACE_MESSAGE_TYPE,ACE_SYNCH_USE >::activate ( | void )`[virtual]`

| Reactivate the queue so that threads can enqueue and dequeue messages again. Returns WAS_INACTIVE if queue was inactive before the call and WAS_ACTIVE if queue was active before the call.

template<classACE_MESSAGE_TYPE, ACE_SYNCH_DECL>
int ACE_Message_Queue_Ex<ACE_MESSAGE_TYPE, >::close ( | void )`[virtual]`

| Close down the message queue and release all resources.

template<classACE_MESSAGE_TYPE, ACE_SYNCH_DECL>
ACE_INLINE int ACE_Message_Queue_Ex< ACE_MESSAGE_TYPE,ACE_SYNCH_USE >::deactivate ( | void )`[virtual]`

| Deactivate the queue and wakeup all threads waiting on the queue so they can continue. No messages are removed from the queue, however. Any other operations called until the queue is activated again will immediately return -1 with <errno> == ESHUTDOWN. Returns WAS_INACTIVE if queue was inactive before the call and WAS_ACTIVE if queue was active before the call.

template<classACE_MESSAGE_TYPE, ACE_SYNCH_DECL>
ACE_INLINE int ACE_Message_Queue_Ex< ACE_MESSAGE_TYPE,ACE_SYNCH_USE >::deactivated ( | void )`[virtual]`

| Returns true if <deactivated_> is enabled.

template<classACE_MESSAGE_TYPE, ACE_SYNCH_DECL>
int ACE_Message_Queue_Ex<ACE_MESSAGE_TYPE, >::dequeue ( | ACE_MESSAGE_TYPE *& first_item,
| ACE_Time_Value * timeout = 0 )`[virtual]`

| This method is an alias for the following <dequeue_head> method.

template<classACE_MESSAGE_TYPE, ACE_SYNCH_DECL>
int ACE_Message_Queue_Ex<ACE_MESSAGE_TYPE, >::dequeue_head ( | ACE_MESSAGE_TYPE *& first_item,
| ACE_Time_Value * timeout = 0 )`[virtual]`

| Dequeue and return the at the head of the queue. Note that <timeout> uses <{absolute}> time rather than <{relative}> time. If the <timeout> elapses without receiving a message -1 is returned and <errno> is set to <EWOULDBLOCK>. If the queue is deactivated -1 is returned and <errno> is set to <ESHUTDOWN>. Otherwise, returns -1 on failure, else the number of items still on the queue.

template<classACE_MESSAGE_TYPE, ACE_SYNCH_DECL>
void ACE_Message_Queue_Ex<ACE_MESSAGE_TYPE, >::dump ( | void ) const`[virtual]`

| Dump the state of an object.

template<classACE_MESSAGE_TYPE, ACE_SYNCH_DECL>
int ACE_Message_Queue_Ex<ACE_MESSAGE_TYPE, >::enqueue ( | ACE_MESSAGE_TYPE * new_item,
| ACE_Time_Value * timeout = 0 )`[virtual]`

| This is an alias for <enqueue_prio>. It's only here for backwards compatibility and will go away in a subsequent release. Please use <enqueue_prio> instead. Note that <timeout> uses <{absolute}> time rather than <{relative}> time.

template<classACE_MESSAGE_TYPE, ACE_SYNCH_DECL>
int ACE_Message_Queue_Ex<ACE_MESSAGE_TYPE, >::enqueue_head ( | ACE_MESSAGE_TYPE * new_item,
| ACE_Time_Value * timeout = 0 )`[virtual]`

| Enqueue an at the head of the queue. Note that <timeout> uses <{absolute}> time rather than <{relative}> time. If the <timeout> elapses without receiving a message -1 is returned and <errno> is set to <EWOULDBLOCK>. If the queue is deactivated -1 is returned and <errno> is set to <ESHUTDOWN>. Otherwise, returns -1 on failure, else the number of items still on the queue.

template<classACE_MESSAGE_TYPE, ACE_SYNCH_DECL>
int ACE_Message_Queue_Ex<ACE_MESSAGE_TYPE, >::enqueue_prio ( | ACE_MESSAGE_TYPE * new_item,
| ACE_Time_Value * timeout = 0 )`[virtual]`

| Enqueue an into the <Message_Queue> in accordance with its <msg_priority> (0 is lowest priority). FIFO order is maintained when messages of the same priority are inserted consecutively. Note that <timeout> uses <{absolute}> time rather than <{relative}> time. If the <timeout> elapses without receiving a message -1 is returned and <errno> is set to <EWOULDBLOCK>. If the queue is deactivated -1 is returned and <errno> is set to <ESHUTDOWN>. Otherwise, returns -1 on failure, else the number of items still on the queue.

template<classACE_MESSAGE_TYPE, ACE_SYNCH_DECL>
int ACE_Message_Queue_Ex<ACE_MESSAGE_TYPE, >::enqueue_tail ( | ACE_MESSAGE_TYPE * new_item,
| ACE_Time_Value * timeout = 0 )`[virtual]`

| Enqueue an at the end of the queue. Note that <timeout> uses <{absolute}> time rather than <{relative}> time. If the <timeout> elapses without receiving a message -1 is returned and <errno> is set to <EWOULDBLOCK>. If the queue is deactivated -1 is returned and <errno> is set to <ESHUTDOWN>. Otherwise, returns -1 on failure, else the number of items still on the queue.

template<classACE_MESSAGE_TYPE, ACE_SYNCH_DECL>
ACE_INLINE void ACE_Message_Queue_Ex< ACE_MESSAGE_TYPE,ACE_SYNCH_USE >::high_water_mark ( | size_t hwm )`[virtual]`

| Set the high watermark, which determines how many bytes can be stored in a queue before it's considered "full."

template<classACE_MESSAGE_TYPE, ACE_SYNCH_DECL>
ACE_INLINE size_t ACE_Message_Queue_Ex< ACE_MESSAGE_TYPE,ACE_SYNCH_USE >::high_water_mark ( | void )`[virtual]`

| Get high watermark.

template<classACE_MESSAGE_TYPE, ACE_SYNCH_DECL>
ACE_INLINE int ACE_Message_Queue_Ex< ACE_MESSAGE_TYPE,ACE_SYNCH_USE >::is_empty ( | void )`[virtual]`

| True if queue is empty, else false.

template<classACE_MESSAGE_TYPE, ACE_SYNCH_DECL>
ACE_INLINE int ACE_Message_Queue_Ex< ACE_MESSAGE_TYPE,ACE_SYNCH_USE >::is_full ( | void )`[virtual]`

| True if queue is full, else false.

template<classACE_MESSAGE_TYPE, ACE_SYNCH_DECL>
ACE_SYNCH_MUTEX_T & ACE_Message_Queue_Ex<ACE_MESSAGE_TYPE, >::lock ( | void )`[inline, virtual]`

| Returns a reference to the lock used by the .

template<classACE_MESSAGE_TYPE, ACE_SYNCH_DECL>
ACE_INLINE void ACE_Message_Queue_Ex< ACE_MESSAGE_TYPE,ACE_SYNCH_USE >::low_water_mark ( | size_t lwm )`[virtual]`

| Set the low watermark, which determines how many bytes must be in the queue before supplier threads are allowed to enqueue additional s.

template<classACE_MESSAGE_TYPE, ACE_SYNCH_DECL>
ACE_INLINE size_t ACE_Message_Queue_Ex< ACE_MESSAGE_TYPE,ACE_SYNCH_USE >::low_water_mark ( | void )`[virtual]`

| Get low watermark.

template<classACE_MESSAGE_TYPE, ACE_SYNCH_DECL>
void ACE_Message_Queue_Ex<ACE_MESSAGE_TYPE, >::message_bytes ( | size_t new_size )`[virtual]`

| New value of the number of total bytes on the queue, i.e., sum of the message block sizes.

template<classACE_MESSAGE_TYPE, ACE_SYNCH_DECL>
ACE_INLINE size_t ACE_Message_Queue_Ex< ACE_MESSAGE_TYPE,ACE_SYNCH_USE >::message_bytes ( | void )`[virtual]`

| Number of total bytes on the queue, i.e., sum of the message block sizes.

template<classACE_MESSAGE_TYPE, ACE_SYNCH_DECL>
ACE_INLINE size_t ACE_Message_Queue_Ex< ACE_MESSAGE_TYPE,ACE_SYNCH_USE >::message_count ( | void )`[virtual]`

| Number of total messages on the queue.

template<classACE_MESSAGE_TYPE, ACE_SYNCH_DECL>
void ACE_Message_Queue_Ex<ACE_MESSAGE_TYPE, >::message_length ( | size_t new_length )`[virtual]`

| New value of the number of total length on the queue, i.e., sum of the message block lengths.

template<classACE_MESSAGE_TYPE, ACE_SYNCH_DECL>
ACE_INLINE size_t ACE_Message_Queue_Ex< ACE_MESSAGE_TYPE,ACE_SYNCH_USE >::message_length ( | void )`[virtual]`

| Number of total length on the queue, i.e., sum of the message block lengths.

template<classACE_MESSAGE_TYPE, ACE_SYNCH_DECL>
ACE_INLINE void ACE_Message_Queue_Ex< ACE_MESSAGE_TYPE,ACE_SYNCH_USE >::notification_strategy ( | ACE_Notification_Strategy * s )`[virtual]`

template<classACE_MESSAGE_TYPE, ACE_SYNCH_DECL>
ACE_INLINE ACE_Notification_Strategy * ACE_Message_Queue_Ex< ACE_MESSAGE_TYPE,ACE_SYNCH_USE >::notification_strategy ( | void )`[virtual]`

| Get/set the notification strategy for the <Message_Queue>.

template<classACE_MESSAGE_TYPE, ACE_SYNCH_DECL>
int ACE_Message_Queue_Ex<ACE_MESSAGE_TYPE, >::notify ( | void )`[virtual]`

| This hook is automatically invoked by <enqueue_head>, <enqueue_tail>, and <enqueue_prio> when a new item is inserted into the queue. Subclasses can override this method to perform specific notification strategies (e.g., signaling events for a <WFMO_Reactor>, notifying a <Reactor>, etc.). In a multi-threaded application with concurrent consumers, there is no guarantee that the queue will be still be non-empty by the time the notification occurs.

template<classACE_MESSAGE_TYPE, ACE_SYNCH_DECL>
int ACE_Message_Queue_Ex<ACE_MESSAGE_TYPE, >::open ( | size_t hwm = ACE_Message_Queue_Base::DEFAULT_HWM,
| size_t lwm = ACE_Message_Queue_Base::DEFAULT_LWM,
| ACE_Notification_Strategy * ns = 0 )`[virtual]`

| Initialize an . The <high_water_mark> determines how many bytes can be stored in a queue before it's considered "full." Supplier threads must block until the queue is no longer full. The <low_water_mark> determines how many bytes must be in the queue before supplier threads are allowed to enqueue additional s. By default, the <high_water_mark> equals the <low_water_mark>, which means that suppliers will be able to enqueue new messages as soon as a consumer removes any message from the queue. Making the <low_water_mark> smaller than the <high_water_mark> forces consumers to drain more messages from the queue before suppliers can enqueue new messages, which can minimize the "silly window syndrome."

template<classACE_MESSAGE_TYPE, ACE_SYNCH_DECL>
int ACE_Message_Queue_Ex<ACE_MESSAGE_TYPE, >::peek_dequeue_head ( | ACE_MESSAGE_TYPE *& first_item,
| ACE_Time_Value * timeout = 0 )`[virtual]`

| Retrieve the first without removing it. Note that <timeout> uses <{absolute}> time rather than <{relative}> time. If the <timeout> elapses without receiving a message -1 is returned and <errno> is set to <EWOULDBLOCK>. If the queue is deactivated -1 is returned and <errno> is set to <ESHUTDOWN>. Otherwise, returns -1 on failure, else the number of items still on the queue.

## Member Data Documentation

template<classACE_MESSAGE_TYPE, ACE_SYNCH_DECL>
ACE_Message_Queue_Ex<ACE_MESSAGE_TYPE, >::ACE_ALLOC_HOOK_DECLARE

| Declare the dynamic allocation hooks.

template<classACE_MESSAGE_TYPE, ACE_SYNCH_DECL>
ACE_Message_Queue< ACE_SYNCH_USE > ACE_Message_Queue_Ex<ACE_MESSAGE_TYPE, >::queue_`[private]`

| Implement this via an .

The documentation for this class was generated from the following files:

- Message_Queue_T.h
- Message_Queue_T.cpp
- Message_Queue_T.i